# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/media/st,stm32mp25-csi.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: STMicroelectronics STM32 CSI controller

description:
  The STM32 CSI controller allows connecting a CSI based
  camera to the DCMIPP camera pipeline.

maintainers:
  - Alain Volmat <alain.volmat@foss.st.com>

properties:
  compatible:
    enum:
      - st,stm32mp25-csi

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clocks:
    maxItems: 3

  clock-names:
    items:
      - const: pclk
      - const: txesc
      - const: csi2phy

  resets:
    maxItems: 1

  vdd-supply:
    description: Digital core power supply (0.91V)

  vdda18-supply:
    description: System analog power supply (1.8V)

  access-controllers:
    minItems: 1
    maxItems: 2

  ports:
    $ref: /schemas/graph.yaml#/properties/ports

    properties:
      port@0:
        $ref: /schemas/graph.yaml#/$defs/port-base
        unevaluatedProperties: false
        description:
          Input port node

        properties:
          endpoint:
            $ref: video-interfaces.yaml#
            unevaluatedProperties: false

            properties:
              data-lanes:
                minItems: 1
                items:
                  - const: 1
                  - const: 2

            required:
              - data-lanes

      port@1:
        $ref: /schemas/graph.yaml#/properties/port
        description:
          Output port node

required:
  - compatible
  - reg
  - interrupts
  - clocks
  - clock-names
  - resets
  - ports

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/st,stm32mp25-rcc.h>
    #include <dt-bindings/interrupt-controller/arm-gic.h>
    #include <dt-bindings/media/video-interfaces.h>
    #include <dt-bindings/reset/st,stm32mp25-rcc.h>
    csi@48020000 {
        compatible = "st,stm32mp25-csi";
        reg = <0x48020000 0x2000>;
        interrupts = <GIC_SPI 142 IRQ_TYPE_LEVEL_HIGH>;
        resets = <&rcc CSI_R>;
        clocks = <&rcc CK_KER_CSI>, <&rcc CK_KER_CSITXESC>, <&rcc CK_KER_CSIPHY>;
        clock-names = "pclk", "txesc", "csi2phy";

        ports {
            #address-cells = <1>;
            #size-cells = <0>;
            port@0 {
                reg = <0>;
                endpoint {
                    remote-endpoint = <&imx335_ep>;
                    data-lanes = <1 2>;
                    bus-type = <MEDIA_BUS_TYPE_CSI2_DPHY>;
                };
            };

            port@1 {
                reg = <1>;
                endpoint {
                    remote-endpoint = <&dcmipp_0>;
                };
            };
        };
    };

...
